diff --git a/libdwfl/dwfl_module_addrsym.c b/libdwfl/dwfl_module_addrsym.c
index d205832..1f0d020 100644
--- a/libdwfl/dwfl_module_addrsym.c
+++ b/libdwfl/dwfl_module_addrsym.c
@@ -27,6 +27,7 @@
    not, see <http://www.gnu.org/licenses/>.  */
 
 #include "libdwflP.h"
+#include "nested_func.h"
 
 /* Returns the name of the symbol "closest" to ADDR.
    Never returns symbols at addresses above ADDR.  */
@@ -37,14 +38,16 @@ __libdwfl_addrsym (Dwfl_Module *mod, GElf_Addr addr, GElf_Off *off,
 		   GElf_Sym *closest_sym, GElf_Word *shndxp,
 		   Elf **elfp, Dwarf_Addr *biasp, bool adjust_st_value)
 {
-  int syments = INTUSE(dwfl_module_getsymtab) (mod);
+  __BLOCK int syments = INTUSE(dwfl_module_getsymtab) (mod);
   if (syments < 0)
     return NULL;
 
   /* Return true iff we consider ADDR to lie in the same section as SYM.  */
-  GElf_Word addr_shndx = SHN_UNDEF;
-  Elf *addr_symelf = NULL;
-  inline bool same_section (GElf_Addr value, Elf *symelf, GElf_Word shndx)
+  __BLOCK GElf_Word addr_shndx = SHN_UNDEF;
+  __BLOCK Elf *addr_symelf = NULL;
+  INLINE_NESTED_FUNC (bool, same_section,
+                      (GElf_Addr, Elf *, GElf_Word),
+                      (GElf_Addr value, Elf *symelf, GElf_Word shndx))
     {
       /* For absolute symbols and the like, only match exactly.  */
       if (shndx >= SHN_LORESERVE)
@@ -87,29 +90,33 @@ __libdwfl_addrsym (Dwfl_Module *mod, GElf_Addr addr, GElf_Off *off,
 	}
 
       return shndx == addr_shndx && addr_symelf == symelf;
-    }
+    };
 
   /* Keep track of the closest symbol we have seen so far.
      Here we store only symbols with nonzero st_size.  */
-  const char *closest_name = NULL;
-  GElf_Addr closest_value = 0;
-  GElf_Word closest_shndx = SHN_UNDEF;
-  Elf *closest_elf = NULL;
+  __BLOCK const char *closest_name = NULL;
+  __BLOCK GElf_Addr closest_value = 0;
+  __BLOCK GElf_Word closest_shndx = SHN_UNDEF;
+  __BLOCK Elf *closest_elf = NULL;
 
   /* Keep track of an eligible symbol with st_size == 0 as a fallback.  */
-  const char *sizeless_name = NULL;
-  GElf_Sym sizeless_sym = { 0, 0, 0, 0, 0, SHN_UNDEF };
-  GElf_Addr sizeless_value = 0;
-  GElf_Word sizeless_shndx = SHN_UNDEF;
-  Elf *sizeless_elf = NULL;
+  __BLOCK const char *sizeless_name = NULL;
+  __BLOCK GElf_Sym sizeless_sym = { 0, 0, 0, 0, 0, SHN_UNDEF };
+  __BLOCK GElf_Addr sizeless_value = 0;
+  __BLOCK GElf_Word sizeless_shndx = SHN_UNDEF;
+  __BLOCK Elf *sizeless_elf = NULL;
 
   /* Keep track of the lowest address a relevant sizeless symbol could have.  */
-  GElf_Addr min_label = 0;
+  __BLOCK GElf_Addr min_label = 0;
 
   /* Try one symbol and associated value from the search table.  */
-  inline void try_sym_value (GElf_Addr value, GElf_Sym *sym,
-			     const char *name, GElf_Word shndx,
-			     Elf *elf, bool resolved)
+  INLINE_NESTED_FUNC (void, try_sym_value,
+                      (GElf_Addr, GElf_Sym *,
+                       const char *, GElf_Word,
+                       Elf *, bool),
+                      (GElf_Addr value, GElf_Sym *sym,
+                       const char *name, GElf_Word shndx,
+                       Elf *elf, bool resolved))
   {
     /* Even if we don't choose this symbol, its existence excludes
        any sizeless symbol (assembly label) that is below its upper
@@ -120,7 +127,9 @@ __libdwfl_addrsym (Dwfl_Module *mod, GElf_Addr addr, GElf_Off *off,
     if (sym->st_size == 0 || addr - value < sym->st_size)
       {
 	/* Return GELF_ST_BIND as higher-is-better integer.  */
-	inline int binding_value (const GElf_Sym *symp)
+	INLINE_NESTED_FUNC (int, binding_value,
+	                    (const GElf_Sym *),
+	                    (const GElf_Sym *symp))
 	{
 	  switch (GELF_ST_BIND (symp->st_info))
 	    {
@@ -133,7 +142,7 @@ __libdwfl_addrsym (Dwfl_Module *mod, GElf_Addr addr, GElf_Off *off,
 	    default:
 	      return 0;
 	    }
-	}
+	};
 
 	/* This symbol is a better candidate than the current one
 	   if it's closer to ADDR or is global when it was local.  */
@@ -185,10 +194,10 @@ __libdwfl_addrsym (Dwfl_Module *mod, GElf_Addr addr, GElf_Off *off,
 	    closest_name = name;
 	  }
       }
-  }
+  };
 
   /* Look through the symbol table for a matching symbol.  */
-  inline void search_table (int start, int end)
+  INLINE_NESTED_FUNC (void, search_table, (int, int), (int start, int end))
     {
       for (int i = start; i < end; ++i)
 	{
@@ -222,7 +231,7 @@ __libdwfl_addrsym (Dwfl_Module *mod, GElf_Addr addr, GElf_Off *off,
 		}
 	    }
 	}
-    }
+    };
 
   /* First go through global symbols.  mod->first_global and
      mod->aux_first_global are setup by dwfl_module_getsymtab to the
diff --git a/libdwfl/dwfl_module_getdwarf.c b/libdwfl/dwfl_module_getdwarf.c
index 93afb76..f772ca7 100644
--- a/libdwfl/dwfl_module_getdwarf.c
+++ b/libdwfl/dwfl_module_getdwarf.c
@@ -33,6 +33,7 @@
 #include <unistd.h>
 #include "../libdw/libdwP.h"	/* DWARF_E_* values are here.  */
 #include "../libelf/libelfP.h"
+#include "nested_func.h"
 
 #ifndef MAX
 # define MAX(a, b) ((a) > (b) ? (a) : (b))
@@ -255,11 +256,11 @@ static Dwfl_Error
 find_prelink_address_sync (Dwfl_Module *mod, struct dwfl_file *file)
 {
   /* The magic section is only identified by name.  */
-  size_t shstrndx;
+  __BLOCK size_t shstrndx;
   if (elf_getshdrstrndx (mod->main.elf, &shstrndx) < 0)
     return DWFL_E_LIBELF;
 
-  Elf_Scn *scn = NULL;
+  __BLOCK Elf_Scn *scn = NULL;
   while ((scn = elf_nextscn (mod->main.elf, scn)) != NULL)
     {
       GElf_Shdr shdr_mem;
@@ -283,7 +284,7 @@ find_prelink_address_sync (Dwfl_Module *mod, struct dwfl_file *file)
     /* There was no .gnu.prelink_undo section.  */
     return DWFL_E_NOERROR;
 
-  Elf_Data *undodata = elf_rawdata (scn, NULL);
+  __BLOCK Elf_Data *undodata = elf_rawdata (scn, NULL);
   if (unlikely (undodata == NULL))
     return DWFL_E_LIBELF;
 
@@ -295,14 +296,14 @@ find_prelink_address_sync (Dwfl_Module *mod, struct dwfl_file *file)
     Elf32_Ehdr e32;
     Elf64_Ehdr e64;
   } ehdr;
-  Elf_Data dst =
+  __BLOCK Elf_Data dst =
     {
       .d_buf = &ehdr,
       .d_size = sizeof ehdr,
       .d_type = ELF_T_EHDR,
       .d_version = EV_CURRENT
     };
-  Elf_Data src = *undodata;
+  __BLOCK Elf_Data src = *undodata;
   src.d_size = gelf_fsize (mod->main.elf, ELF_T_EHDR, 1, EV_CURRENT);
   src.d_type = ELF_T_EHDR;
   if (unlikely (gelf_xlatetom (mod->main.elf, &dst, &src,
@@ -310,11 +311,11 @@ find_prelink_address_sync (Dwfl_Module *mod, struct dwfl_file *file)
 		== NULL))
     return DWFL_E_LIBELF;
 
-  size_t shentsize = gelf_fsize (mod->main.elf, ELF_T_SHDR, 1, EV_CURRENT);
-  size_t phentsize = gelf_fsize (mod->main.elf, ELF_T_PHDR, 1, EV_CURRENT);
+  __BLOCK size_t shentsize = gelf_fsize (mod->main.elf, ELF_T_SHDR, 1, EV_CURRENT);
+  __BLOCK size_t phentsize = gelf_fsize (mod->main.elf, ELF_T_PHDR, 1, EV_CURRENT);
 
-  uint_fast16_t phnum;
-  uint_fast16_t shnum;
+  __BLOCK uint_fast16_t phnum;
+  __BLOCK uint_fast16_t shnum;
   if (ehdr.e32.e_ident[EI_CLASS] == ELFCLASS32)
     {
       if (ehdr.e32.e_shentsize != shentsize
@@ -417,9 +418,9 @@ find_prelink_address_sync (Dwfl_Module *mod, struct dwfl_file *file)
 
   const int shdrs_bytes =
       (shnum - 1) * MAX (sizeof (Elf32_Shdr), sizeof (Elf64_Shdr));
-  void *shdrs = malloc (shdrs_bytes);
-  Elf32_Shdr *s32 = shdrs;
-  Elf64_Shdr *s64 = shdrs;
+  __BLOCK void *shdrs = malloc (shdrs_bytes);
+  __BLOCK Elf32_Shdr *s32 = shdrs;
+  __BLOCK Elf64_Shdr *s64 = shdrs;
   if (unlikely (shdrs == NULL))
     return DWFL_E_NOMEM;
   dst.d_buf = shdrs;
@@ -447,13 +448,19 @@ find_prelink_address_sync (Dwfl_Module *mod, struct dwfl_file *file)
      image remaining the same but being spread across the two sections.
      So we consider the highest section end, which still matches up.  */
 
-  GElf_Addr highest;
-
-  inline void consider_shdr (GElf_Addr interp,
-			     GElf_Word sh_type,
-			     GElf_Xword sh_flags,
-			     GElf_Addr sh_addr,
-			     GElf_Xword sh_size)
+  __BLOCK GElf_Addr highest;
+
+  INLINE_NESTED_FUNC (void, consider_shdr,
+                      (GElf_Addr,
+                       GElf_Word,
+                       GElf_Xword,
+                       GElf_Addr,
+                       GElf_Xword),
+                      (GElf_Addr interp,
+                       GElf_Word sh_type,
+                       GElf_Xword sh_flags,
+                       GElf_Addr sh_addr,
+                       GElf_Xword sh_size))
   {
     if ((sh_flags & SHF_ALLOC)
 	&& ((sh_type == SHT_PROGBITS && sh_addr != interp)
@@ -463,7 +470,7 @@ find_prelink_address_sync (Dwfl_Module *mod, struct dwfl_file *file)
 	if (sh_end > highest)
 	  highest = sh_end;
       }
-  }
+  };
 
   highest = 0;
   scn = NULL;
@@ -675,17 +682,17 @@ find_offsets (Elf *elf, GElf_Addr main_bias, size_t phnum, size_t n,
 static void
 find_dynsym (Dwfl_Module *mod)
 {
-  GElf_Ehdr ehdr_mem;
-  GElf_Ehdr *ehdr = gelf_getehdr (mod->main.elf, &ehdr_mem);
+  __BLOCK GElf_Ehdr ehdr_mem;
+  __BLOCK GElf_Ehdr *ehdr = gelf_getehdr (mod->main.elf, &ehdr_mem);
 
-  size_t phnum;
+  __BLOCK size_t phnum;
   if (unlikely (elf_getphdrnum (mod->main.elf, &phnum) != 0))
     return;
 
   for (size_t i = 0; i < phnum; ++i)
     {
-      GElf_Phdr phdr_mem;
-      GElf_Phdr *phdr = gelf_getphdr (mod->main.elf, i, &phdr_mem);
+      __BLOCK GElf_Phdr phdr_mem;
+      __BLOCK GElf_Phdr *phdr = gelf_getphdr (mod->main.elf, i, &phdr_mem);
       if (phdr == NULL)
 	break;
 
@@ -693,7 +700,7 @@ find_dynsym (Dwfl_Module *mod)
 	{
 	  /* Examine the dynamic section for the pointers we need.  */
 
-	  Elf_Data *data = elf_getdata_rawchunk (mod->main.elf,
+	  __BLOCK Elf_Data *data = elf_getdata_rawchunk (mod->main.elf,
 						 phdr->p_offset, phdr->p_filesz,
 						 ELF_T_DYN);
 	  if (data == NULL)
@@ -707,10 +714,17 @@ find_dynsym (Dwfl_Module *mod)
 	      i_gnu_hash,
 	      i_max
 	    };
+#if __clang__
+	  /* Clang Blocks cannot copy an array to a closure. */
+	  GElf_Addr *addrs = alloca ((int) i_max * sizeof (GElf_Addr));
+	  memset (addrs, 0, i_max * sizeof (GElf_Addr));
+#else
+	  /* gcc complains about unbounded stack usage from alloca. */
 	  GElf_Addr addrs[i_max] = { 0, };
-	  GElf_Xword strsz = 0;
-	  size_t n = data->d_size / gelf_fsize (mod->main.elf,
-						ELF_T_DYN, 1, EV_CURRENT);
+#endif
+	  __BLOCK GElf_Xword strsz = 0;
+	  __BLOCK size_t n =
+		  data->d_size / gelf_fsize (mod->main.elf, ELF_T_DYN, 1, EV_CURRENT);
 	  for (size_t j = 0; j < n; ++j)
 	    {
 	      GElf_Dyn dyn_mem;
@@ -749,7 +763,8 @@ find_dynsym (Dwfl_Module *mod)
 
 	  /* Translate pointers into file offsets.  ADJUST is either zero
 	     in case the dynamic segment wasn't adjusted or mod->main_bias.  */
-	  void translate_offs (GElf_Addr adjust)
+	  NESTED_FUNC (void, translate_offs,
+	               (GElf_Addr), (GElf_Addr adjust))
 	  {
 	    GElf_Off offs[i_max] = { 0, };
 	    find_offsets (mod->main.elf, adjust, phnum, i_max, addrs, offs);
@@ -864,7 +879,7 @@ find_dynsym (Dwfl_Module *mod)
 		    mod->symerr = DWFL_E_NOERROR;
 		  }
 	      }
-	  }
+	  };
 
 	  /* First try unadjusted, like ELF files from disk, vdso.
 	     Then try for already adjusted dynamic section, like ELF
diff --git a/libdwfl/dwfl_module_getsrc_file.c b/libdwfl/dwfl_module_getsrc_file.c
index 20aa8a5..7ec8652 100644
--- a/libdwfl/dwfl_module_getsrc_file.c
+++ b/libdwfl/dwfl_module_getsrc_file.c
@@ -28,6 +28,7 @@
 
 #include "libdwflP.h"
 #include "../libdw/libdwP.h"
+#include "nested_func.h"
 
 
 int
@@ -45,31 +46,34 @@ dwfl_module_getsrc_file (Dwfl_Module *mod,
 	return -1;
     }
 
-  bool is_basename = strchr (fname, '/') == NULL;
+  const bool is_basename = strchr (fname, '/') == NULL;
 
-  size_t max_match = *nsrcs ?: ~0u;
-  size_t act_match = *nsrcs;
-  size_t cur_match = 0;
-  Dwfl_Line **match = *nsrcs == 0 ? NULL : *srcsp;
+  __BLOCK size_t max_match = *nsrcs ?: ~0u;
+  __BLOCK size_t act_match = *nsrcs;
+  __BLOCK size_t cur_match = 0;
+  __BLOCK Dwfl_Line **match = *nsrcs == 0 ? NULL : *srcsp;
 
-  struct dwfl_cu *cu = NULL;
+  __BLOCK struct dwfl_cu *cu = NULL;
   Dwfl_Error error;
   while ((error = __libdwfl_nextcu (mod, cu, &cu)) == DWFL_E_NOERROR
 	 && cu != NULL
 	 && (error = __libdwfl_cu_getsrclines (cu)) == DWFL_E_NOERROR)
     {
-      inline const char *INTUSE(dwarf_line_file) (const Dwarf_Line *line)
+      INLINE_INTUSE_NESTED_FUNC (const char *, dwarf_line_file,
+                                 (const Dwarf_Line *), (const Dwarf_Line *line))
 	{
 	  return line->files->info[line->file].name;
-	}
-      inline Dwarf_Line *dwfl_line (const Dwfl_Line *line)
+	};
+      INLINE_NESTED_FUNC (Dwarf_Line *, dwfl_line,
+                          (const Dwfl_Line *), (const Dwfl_Line *line))
 	{
 	  return &dwfl_linecu (line)->die.cu->lines->info[line->idx];
-	}
-      inline const char *dwfl_line_file (const Dwfl_Line *line)
+	};
+      INLINE_NESTED_FUNC (const char *, dwfl_line_file,
+                          (const Dwfl_Line *), (const Dwfl_Line *line))
 	{
 	  return INTUSE(dwarf_line_file) (dwfl_line (line));
-	}
+	};
 
       /* Search through all the line number records for a matching
 	 file and line/column number.  If any of the numbers is zero,
diff --git a/libdwfl/dwfl_segment_report_module.c b/libdwfl/dwfl_segment_report_module.c
index 43742ef..82581f3 100644
--- a/libdwfl/dwfl_segment_report_module.c
+++ b/libdwfl/dwfl_segment_report_module.c
@@ -31,6 +31,7 @@
 #undef	_
 #include "libdwflP.h"
 #include "common.h"
+#include "nested_func.h"
 
 #include <elf.h>
 #include <gelf.h>
@@ -236,15 +237,18 @@ invalid_elf (Elf *elf, bool disk_file_has_build_id,
 }
 
 int
-dwfl_segment_report_module (Dwfl *dwfl, int ndx, const char *name,
-			    Dwfl_Memory_Callback *memory_callback,
-			    void *memory_callback_arg,
-			    Dwfl_Module_Callback *read_eagerly,
-			    void *read_eagerly_arg,
-			    const void *note_file, size_t note_file_size,
-			    const struct r_debug_info *r_debug_info)
+dwfl_segment_report_module (Dwfl *dwfl, int const ndx_in, const char* const name_in,
+			    Dwfl_Memory_Callback* const memory_callback,
+			    void* const memory_callback_arg,
+			    Dwfl_Module_Callback * const read_eagerly,
+			    void* const read_eagerly_arg,
+			    const void* const note_file, size_t const note_file_size,
+			    const struct r_debug_info* const r_debug_info)
 {
-  size_t segment = ndx;
+  __BLOCK int ndx = ndx_in;
+  __BLOCK const char *name = name_in;
+
+  __BLOCK size_t segment = ndx;
 
   if (segment >= dwfl->lookup_elts)
     segment = dwfl->lookup_elts - 1;
@@ -258,34 +262,38 @@ dwfl_segment_report_module (Dwfl *dwfl, int ndx, const char *name,
     if (++segment == dwfl->lookup_elts)
       return 0;
 
-  GElf_Addr start = dwfl->lookup_addr[segment];
+  __BLOCK GElf_Addr start = dwfl->lookup_addr[segment];
 
-  inline bool segment_read (int segndx,
-			    void **buffer, size_t *buffer_available,
-			    GElf_Addr addr, size_t minread)
+  INLINE_NESTED_FUNC (bool, segment_read,
+                      (int , void **, size_t *, GElf_Addr, size_t),
+                      (int segndx,
+                       void **buffer, size_t *buffer_available,
+                       GElf_Addr addr, size_t minread))
   {
     return ! (*memory_callback) (dwfl, segndx, buffer, buffer_available,
 				 addr, minread, memory_callback_arg);
-  }
+  };
 
-  inline void release_buffer (void **buffer, size_t *buffer_available)
+  INLINE_NESTED_FUNC (void, release_buffer,
+                      (void **, size_t *),
+                      (void **buffer, size_t *buffer_available))
   {
     if (*buffer != NULL)
       (void) segment_read (-1, buffer, buffer_available, 0, 0);
-  }
+  };
 
   /* First read in the file header and check its sanity.  */
 
-  void *buffer = NULL;
-  size_t buffer_available = INITIAL_READ;
-  Elf *elf = NULL;
-  int fd = -1;
+  __BLOCK void *buffer = NULL;
+  __BLOCK size_t buffer_available = INITIAL_READ;
+  __BLOCK Elf *elf = NULL;
+  __BLOCK int fd = -1;
 
   /* We might have to reserve some memory for the phdrs.  Set to NULL
      here so we can always safely free it.  */
-  void *phdrsp = NULL;
+  __BLOCK void *phdrsp = NULL;
 
-  inline int finish (void)
+  INLINE_NESTED_FUNC (int, finish, (void), (void))
   {
     free (phdrsp);
     release_buffer (&buffer, &buffer_available);
@@ -294,15 +302,17 @@ dwfl_segment_report_module (Dwfl *dwfl, int ndx, const char *name,
     if (fd != -1)
       close (fd);
     return ndx;
-  }
+  };
 
   if (segment_read (ndx, &buffer, &buffer_available,
 		    start, sizeof (Elf64_Ehdr))
       || memcmp (buffer, ELFMAG, SELFMAG) != 0)
     return finish ();
 
-  inline bool read_portion (void **data, size_t *data_size,
-			    GElf_Addr vaddr, size_t filesz)
+  INLINE_NESTED_FUNC (bool, read_portion,
+                      (void **, size_t *, GElf_Addr, size_t),
+                      (void **data, size_t *data_size,
+                       GElf_Addr vaddr, size_t filesz))
   {
     if (vaddr - start + filesz > buffer_available
 	/* If we're in string mode, then don't consider the buffer we have
@@ -320,35 +330,37 @@ dwfl_segment_report_module (Dwfl *dwfl, int ndx, const char *name,
     *data = vaddr - start + buffer;
     *data_size = 0;
     return false;
-  }
+  };
 
-  inline void finish_portion (void **data, size_t *data_size)
+  INLINE_NESTED_FUNC (void, finish_portion,
+                      (void **, size_t *),
+                      (void **data, size_t *data_size))
   {
     if (*data_size != 0)
       release_buffer (data, data_size);
-  }
+  };
 
   /* Extract the information we need from the file header.  */
-  const unsigned char *e_ident;
-  unsigned char ei_class;
-  unsigned char ei_data;
-  uint16_t e_type;
-  union
+  __BLOCK const unsigned char *e_ident;
+  __BLOCK unsigned char ei_class;
+  __BLOCK unsigned char ei_data;
+  __BLOCK uint16_t e_type;
+  __BLOCK union
   {
     Elf32_Ehdr e32;
     Elf64_Ehdr e64;
   } ehdr;
-  GElf_Off phoff;
-  uint_fast16_t phnum;
-  uint_fast16_t phentsize;
-  GElf_Off shdrs_end;
-  Elf_Data xlatefrom =
+  __BLOCK GElf_Off phoff;
+  __BLOCK uint_fast16_t phnum;
+  __BLOCK uint_fast16_t phentsize;
+  __BLOCK GElf_Off shdrs_end;
+  __BLOCK Elf_Data xlatefrom =
     {
       .d_type = ELF_T_EHDR,
       .d_buf = (void *) buffer,
       .d_version = EV_CURRENT,
     };
-  Elf_Data xlateto =
+  __BLOCK Elf_Data xlateto =
     {
       .d_type = ELF_T_EHDR,
       .d_buf = &ehdr,
@@ -400,8 +412,8 @@ dwfl_segment_report_module (Dwfl *dwfl, int ndx, const char *name,
   xlatefrom.d_type = xlateto.d_type = ELF_T_PHDR;
   xlatefrom.d_size = phnum * phentsize;
 
-  void *ph_buffer = NULL;
-  size_t ph_buffer_size = 0;
+  __BLOCK void *ph_buffer = NULL;
+  __BLOCK size_t ph_buffer_size = 0;
   if (read_portion (&ph_buffer, &ph_buffer_size,
 		    start + phoff, xlatefrom.d_size))
     return finish ();
@@ -411,8 +423,8 @@ dwfl_segment_report_module (Dwfl *dwfl, int ndx, const char *name,
   const int phdrsp_bytes =
       phnum * MAX (sizeof (Elf32_Phdr), sizeof (Elf64_Phdr));
   phdrsp = malloc (phdrsp_bytes);
-  Elf32_Phdr *p32 = phdrsp;
-  Elf64_Phdr *p64 = phdrsp;
+  __BLOCK Elf32_Phdr *p32 = phdrsp;
+  __BLOCK Elf64_Phdr *p64 = phdrsp;
   if (unlikely (phdrsp == NULL))
     return finish ();
 
@@ -420,31 +432,33 @@ dwfl_segment_report_module (Dwfl *dwfl, int ndx, const char *name,
   xlateto.d_size = phdrsp_bytes;
 
   /* Track the bounds of the file visible in memory.  */
-  GElf_Off file_trimmed_end = 0; /* Proper p_vaddr + p_filesz end.  */
-  GElf_Off file_end = 0;	 /* Rounded up to effective page size.  */
-  GElf_Off contiguous = 0;	 /* Visible as contiguous file from START.  */
-  GElf_Off total_filesz = 0;	 /* Total size of data to read.  */
+  __BLOCK GElf_Off file_trimmed_end = 0; /* Proper p_vaddr + p_filesz end.  */
+  __BLOCK GElf_Off file_end = 0;	 /* Rounded up to effective page size.  */
+  __BLOCK GElf_Off contiguous = 0;	 /* Visible as contiguous file from START.  */
+  __BLOCK GElf_Off total_filesz = 0;	 /* Total size of data to read.  */
 
   /* Collect the bias between START and the containing PT_LOAD's p_vaddr.  */
-  GElf_Addr bias = 0;
-  bool found_bias = false;
+  __BLOCK GElf_Addr bias = 0;
+  __BLOCK bool found_bias = false;
 
   /* Collect the unbiased bounds of the module here.  */
-  GElf_Addr module_start = -1l;
-  GElf_Addr module_end = 0;
-  GElf_Addr module_address_sync = 0;
+  __BLOCK GElf_Addr module_start = -1l;
+  __BLOCK GElf_Addr module_end = 0;
+  __BLOCK GElf_Addr module_address_sync = 0;
 
   /* If we see PT_DYNAMIC, record it here.  */
-  GElf_Addr dyn_vaddr = 0;
-  GElf_Xword dyn_filesz = 0;
+  __BLOCK GElf_Addr dyn_vaddr = 0;
+  __BLOCK GElf_Xword dyn_filesz = 0;
 
   /* Collect the build ID bits here.  */
-  void *build_id = NULL;
-  size_t build_id_len = 0;
-  GElf_Addr build_id_vaddr = 0;
+  __BLOCK void *build_id = NULL;
+  __BLOCK size_t build_id_len = 0;
+  __BLOCK GElf_Addr build_id_vaddr = 0;
 
   /* Consider a PT_NOTE we've found in the image.  */
-  inline void consider_notes (GElf_Addr vaddr, GElf_Xword filesz)
+  INLINE_NESTED_FUNC (void, consider_notes,
+                      (GElf_Addr, GElf_Xword),
+                      (GElf_Addr vaddr, GElf_Xword filesz))
   {
     /* If we have already seen a build ID, we don't care any more.  */
     if (build_id != NULL || filesz == 0)
@@ -504,13 +518,18 @@ dwfl_segment_report_module (Dwfl *dwfl, int ndx, const char *name,
     if (notes != data)
       free (notes);
     finish_portion (&data, &data_size);
-  }
+  };
 
   /* Consider each of the program headers we've read from the image.  */
-  inline void consider_phdr (GElf_Word type,
-			     GElf_Addr vaddr, GElf_Xword memsz,
-			     GElf_Off offset, GElf_Xword filesz,
-			     GElf_Xword align)
+  INLINE_NESTED_FUNC (void, consider_phdr,
+                      (GElf_Word,
+                       GElf_Addr, GElf_Xword,
+                       GElf_Off, GElf_Xword,
+                       GElf_Xword),
+                      (GElf_Word type,
+                       GElf_Addr vaddr, GElf_Xword memsz,
+                       GElf_Off offset, GElf_Xword filesz,
+                       GElf_Xword align))
   {
     switch (type)
       {
@@ -573,7 +592,7 @@ dwfl_segment_report_module (Dwfl *dwfl, int ndx, const char *name,
 	  module_end = vaddr_end;
 	break;
       }
-  }
+  };
   if (ei_class == ELFCLASS32)
     {
       if (elf32_xlatetom (&xlateto, &xlatefrom, ei_data) == NULL)
@@ -717,11 +736,12 @@ dwfl_segment_report_module (Dwfl *dwfl, int ndx, const char *name,
      We need its DT_STRTAB and DT_STRSZ to decipher DT_SONAME,
      and they also tell us the essential portion of the file
      for fetching symbols.  */
-  GElf_Addr soname_stroff = 0;
-  GElf_Addr dynstr_vaddr = 0;
-  GElf_Xword dynstrsz = 0;
-  bool execlike = false;
-  inline bool consider_dyn (GElf_Sxword tag, GElf_Xword val)
+  __BLOCK GElf_Addr soname_stroff = 0;
+  __BLOCK GElf_Addr dynstr_vaddr = 0;
+  __BLOCK GElf_Xword dynstrsz = 0;
+  __BLOCK bool execlike = false;
+  INLINE_NESTED_FUNC (bool, consider_dyn, (GElf_Sxword, GElf_Xword),
+                      (GElf_Sxword tag, GElf_Xword val))
   {
     switch (tag)
       {
@@ -746,7 +766,7 @@ dwfl_segment_report_module (Dwfl *dwfl, int ndx, const char *name,
       }
 
     return soname_stroff != 0 && dynstr_vaddr != 0 && dynstrsz != 0;
-  }
+  };
 
   const size_t dyn_entsize = (ei_class == ELFCLASS32
 			      ? sizeof (Elf32_Dyn) : sizeof (Elf64_Dyn));
@@ -755,9 +775,9 @@ dwfl_segment_report_module (Dwfl *dwfl, int ndx, const char *name,
   if (dyn_filesz != 0 && dyn_filesz % dyn_entsize == 0
       && ! read_portion (&dyn_data, &dyn_data_size, dyn_vaddr, dyn_filesz))
     {
-      void *dyns = malloc (dyn_filesz);
-      Elf32_Dyn *d32 = dyns;
-      Elf64_Dyn *d64 = dyns;
+      __BLOCK void *dyns = malloc (dyn_filesz);
+      __BLOCK Elf32_Dyn *d32 = dyns;
+      __BLOCK Elf64_Dyn *d64 = dyns;
       if (unlikely (dyns == NULL))
 	return finish ();
 
@@ -789,8 +809,8 @@ dwfl_segment_report_module (Dwfl *dwfl, int ndx, const char *name,
   if (name == NULL)
     name = e_type == ET_EXEC ? "[exe]" : execlike ? "[pie]" : "[dso]";
 
-  void *soname = NULL;
-  size_t soname_size = 0;
+  __BLOCK void *soname = NULL;
+  __BLOCK size_t soname_size = 0;
   if (! name_is_final && dynstrsz != 0 && dynstr_vaddr != 0)
     {
       /* We know the bounds of the .dynstr section.
@@ -823,7 +843,7 @@ dwfl_segment_report_module (Dwfl *dwfl, int ndx, const char *name,
   /* Now that we have chosen the module's name and bounds, report it.
      If we found a build ID, report that too.  */
 
-  Dwfl_Module *mod = INTUSE(dwfl_report_module) (dwfl, name,
+  __BLOCK Dwfl_Module *mod = INTUSE(dwfl_report_module) (dwfl, name,
 						 module_start, module_end);
 
   // !execlike && ET_EXEC is PIE.
@@ -871,29 +891,34 @@ dwfl_segment_report_module (Dwfl *dwfl, int ndx, const char *name,
       /* The caller wants to read the whole file in right now, but hasn't
 	 done it for us.  Fill in a local image of the virtual file.  */
 
-      void *contents = calloc (1, file_trimmed_end);
+      __BLOCK void *contents = calloc (1, file_trimmed_end);
       if (unlikely (contents == NULL))
 	return finish ();
 
-      inline void final_read (size_t offset, GElf_Addr vaddr, size_t size)
+      INLINE_NESTED_FUNC (void, final_read,
+                          (size_t, GElf_Addr, size_t),
+                          (size_t offset, GElf_Addr vaddr, size_t size))
       {
 	void *into = contents + offset;
 	size_t read_size = size;
 	(void) segment_read (addr_segndx (dwfl, segment, vaddr, false),
 			     &into, &read_size, vaddr, size);
-      }
+      };
 
       if (contiguous < file_trimmed_end)
 	{
 	  /* We can't use the memory image verbatim as the file image.
 	     So we'll be reading into a local image of the virtual file.  */
 
-	  inline void read_phdr (GElf_Word type, GElf_Addr vaddr,
-				 GElf_Off offset, GElf_Xword filesz)
+	  INLINE_NESTED_FUNC (void, read_phdr,
+	                      (GElf_Word, GElf_Addr,
+	                       GElf_Off, GElf_Xword),
+	                      (GElf_Word type, GElf_Addr vaddr,
+	                       GElf_Off offset, GElf_Xword filesz))
 	  {
 	    if (type == PT_LOAD)
 	      final_read (offset, vaddr + bias, filesz);
-	  }
+	  };
 
 	  if (ei_class == ELFCLASS32)
 	    for (uint_fast16_t i = 0; i < phnum; ++i)
